// TraderSpi.cpp: implementation of the CTraderSpi class.
//
//////////////////////////////////////////////////////////////////////

#include "TraderSpi.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


extern FILE * g_fpRecv;

CTraderSpi::CTraderSpi(CUstpFtdcTraderApi *pTrader):m_pUserApi(pTrader)
{

}

CTraderSpi::~CTraderSpi()
{

}


void CTraderSpi::OnFrontConnected()
{
	CUstpFtdcReqUserLoginField reqUserLogin;
	memset(&reqUserLogin,0,sizeof(CUstpFtdcReqUserLoginField));		
	strcpy(reqUserLogin.BrokerID,g_BrokerID);
	strcpy(reqUserLogin.UserID, g_UserID);
	strcpy(reqUserLogin.Password, g_Password);	
	strcpy(reqUserLogin.UserProductInfo,g_pProductInfo);		
	m_pUserApi->ReqUserLogin(&reqUserLogin, g_nOrdLocalID);	
	
	printf("¼BrokerID=[%s]UserID=[%s]\n",g_BrokerID,g_UserID);
#ifdef WIN32
	Sleep(1000);
#else
	usleep(1000);
#endif
}


void CTraderSpi::OnRspUserLogin(CUstpFtdcRspUserLoginField *pRspUserLogin, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("¼ʧ...ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	g_nOrdLocalID=atoi(pRspUserLogin->MaxOrderLocalID)+1;
 	printf("-----------------------------\n");
 	printf("¼ɹ󱾵ر:%d\n",g_nOrdLocalID);
 	printf("-----------------------------\n");

 	StartAutoOrder();//ӳɹͿʼһ߳̿ʼ hui
}

void CTraderSpi::OnRspOrderInsert(CUstpFtdcInputOrderField *pInputOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pInputOrder==NULL)
	{
		printf("ûб\n");
		return;
	}
	printf("-----------------------------\n");
	printf("ɹ\n");
	printf("-----------------------------\n");
	return ;
	
}
void CTraderSpi::OnRtnTrade(CUstpFtdcTradeField *pTrade)
{
	printf("-----------------------------\n");
	printf("յɽر\n");
	Show(pTrade);
	printf("-----------------------------\n");
	return;
}

void CTraderSpi::Show(CUstpFtdcOrderField *pOrder)
{
	printf("-----------------------------\n");
	printf("=[%s]\n",pOrder->ExchangeID);
	printf("=[%s]\n",pOrder->TradingDay);
	printf("Ա=[%s]\n",pOrder->ParticipantID);
	printf("µϯλ=[%s]\n",pOrder->SeatID);
	printf("Ͷ߱=[%s]\n",pOrder->InvestorID);
	printf("ͻ=[%s]\n",pOrder->ClientID);
	printf("ϵͳ=[%s]\n",pOrder->OrderSysID);
	printf("ر=[%s]\n",pOrder->OrderLocalID);
	printf("ûر=[%s]\n",pOrder->UserOrderLocalID);
	printf("Լ=[%s]\n",pOrder->InstrumentID);
	printf("۸=[%c]\n",pOrder->OrderPriceType);
	printf("=[%c]\n",pOrder->Direction);
	printf("ƽ־=[%c]\n",pOrder->OffsetFlag);
	printf("Ͷױ־=[%c]\n",pOrder->HedgeFlag);
	printf("۸=[%lf]\n",pOrder->LimitPrice);
	printf("=[%d]\n",pOrder->Volume);
	printf("Դ=[%c]\n",pOrder->OrderSource);
	printf("״̬=[%c]\n",pOrder->OrderStatus);
	printf("ʱ=[%s]\n",pOrder->InsertTime);
	printf("ʱ=[%s]\n",pOrder->CancelTime);
	printf("Ч=[%c]\n",pOrder->TimeCondition);
	printf("GTD=[%s]\n",pOrder->GTDDate);
	printf("Сɽ=[%d]\n",pOrder->MinVolume);
	printf("ֹ=[%lf]\n",pOrder->StopPrice);
	printf("ǿƽԭ=[%c]\n",pOrder->ForceCloseReason);
	printf("Զ־=[%d]\n",pOrder->IsAutoSuspend);
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRtnOrder(CUstpFtdcOrderField *pOrder)
{
	printf("-----------------------------\n");
	printf("յر\n");
	Show(pOrder);
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRspOrderAction(CUstpFtdcOrderActionField *pOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pOrderAction==NULL)
	{
		printf("ûг\n");
		return;
	}
	printf("-----------------------------\n");
	printf("ɹ\n");
	printf("-----------------------------\n");
	return ;
}
void CTraderSpi::OnRspUserPasswordUpdate(CUstpFtdcUserPasswordUpdateField *pUserPasswordUpdate, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("޸ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pUserPasswordUpdate==NULL)
	{
		printf("û޸\n");
		return;
	}
	printf("-----------------------------\n");
	printf("޸ɹ\n");
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnErrRtnOrderInsert(CUstpFtdcInputOrderField *pInputOrder, CUstpFtdcRspInfoField *pRspInfo)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("رʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pInputOrder==NULL)
	{
		printf("û\n");
		return;
	}
	printf("-----------------------------\n");
	printf("ر\n");
	printf("-----------------------------\n");
	return ;
}
void CTraderSpi::OnErrRtnOrderAction(CUstpFtdcOrderActionField *pOrderAction, CUstpFtdcRspInfoField *pRspInfo)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("رʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pOrderAction==NULL)
	{
		printf("û\n");
		return;
	}
	printf("-----------------------------\n");
	printf("ر\n");
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRspQryOrder(CUstpFtdcOrderField *pOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pOrder==NULL)
	{
		printf("ûвѯ\n");
		return;
	}
	Show(pOrder);
	return ;
}
void CTraderSpi::Show(CUstpFtdcTradeField *pTrade)
{
	printf("-----------------------------\n");
	printf("=[%s]\n",pTrade->ExchangeID);
	printf("=[%s]\n",pTrade->TradingDay);
	printf("Ա=[%s]\n",pTrade->ParticipantID);
	printf("µϯλ=[%s]\n",pTrade->SeatID);
	printf("Ͷ߱=[%s]\n",pTrade->InvestorID);
	printf("ͻ=[%s]\n",pTrade->ClientID);
	printf("ɽ=[%s]\n",pTrade->TradeID);

	printf("ûر=[%s]\n",pTrade->UserOrderLocalID);
	printf("Լ=[%s]\n",pTrade->InstrumentID);
	printf("=[%c]\n",pTrade->Direction);
	printf("ƽ־=[%c]\n",pTrade->OffsetFlag);
	printf("Ͷױ־=[%c]\n",pTrade->HedgeFlag);
	printf("ɽ۸=[%lf]\n",pTrade->TradePrice);
	printf("ɽ=[%d]\n",pTrade->TradeVolume);
	printf("Ա=[%s]\n",pTrade->ClearingPartID);
	
	printf("-----------------------------\n");
	return ;
}
void CTraderSpi::OnRspQryTrade(CUstpFtdcTradeField *pTrade, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯɽʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pTrade==NULL)
	{
		printf("ûвѯɽ");
		return;
	}
	Show(pTrade);
	return ;
}
void CTraderSpi::OnRspQryExchange(CUstpFtdcRspExchangeField *pRspExchange, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if (pRspExchange==NULL)
	{
		printf("ûвѯϢ\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("[%s]\n",pRspExchange->ExchangeID);
	printf("[%s]\n",pRspExchange->ExchangeName);
	printf("-----------------------------\n");
	return;
}

void CTraderSpi::OnRspQryInvestorAccount(CUstpFtdcRspInvestorAccountField *pRspInvestorAccount, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯͶ˻ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	
	if (pRspInvestorAccount==NULL)
	{
		printf("ûвѯͶ˻\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("Ͷ߱=[%s]\n",pRspInvestorAccount->InvestorID);
	printf("ʽʺ=[%s]\n",pRspInvestorAccount->AccountID);
	printf("ϴν׼=[%lf]\n",pRspInvestorAccount->PreBalance);
	printf("=[%lf]\n",pRspInvestorAccount->Deposit);
	printf("=[%lf]\n",pRspInvestorAccount->Withdraw);
	printf("ı֤=[%lf]\n",pRspInvestorAccount->FrozenMargin);
	printf("=[%lf]\n",pRspInvestorAccount->FrozenFee);
	printf("=[%lf]\n",pRspInvestorAccount->Fee);
	printf("ƽӯ=[%lf]\n",pRspInvestorAccount->CloseProfit);
	printf("ֲӯ=[%lf]\n",pRspInvestorAccount->PositionProfit);
	printf("ʽ=[%lf]\n",pRspInvestorAccount->Available);
	printf("ͷı֤=[%lf]\n",pRspInvestorAccount->LongFrozenMargin);
	printf("ͷı֤=[%lf]\n",pRspInvestorAccount->ShortFrozenMargin);
	printf("ͷ֤=[%lf]\n",pRspInvestorAccount->LongMargin);
	printf("ͷ֤=[%lf]\n",pRspInvestorAccount->ShortMargin);
	printf("-----------------------------\n");

}

void CTraderSpi::OnRspQryUserInvestor(CUstpFtdcRspUserInvestorField *pUserInvestor, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯͶʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if (pUserInvestor==NULL)
	{
		printf("No data\n");
		return ;
	}
	
	printf("InvestorID=[%s]\n",pUserInvestor->InvestorID);
}

void CTraderSpi::Show(CUstpFtdcRspInstrumentField *pRspInstrument)
{
	printf("-----------------------------\n");
	printf("=[%s]\n",pRspInstrument->ExchangeID);
	printf("Ʒִ=[%s]\n",pRspInstrument->ProductID);
	printf("Ʒ=[%s]\n",pRspInstrument->ProductName);
	printf("Լ=[%s]\n",pRspInstrument->InstrumentID);
	printf("Լ=[%s]\n",pRspInstrument->InstrumentName);
	printf("=[%d]\n",pRspInstrument->DeliveryYear);
	printf("=[%d]\n",pRspInstrument->DeliveryMonth);
	printf("޼۵µ=[%d]\n",pRspInstrument->MaxLimitOrderVolume);
	printf("޼۵Сµ=[%d]\n",pRspInstrument->MinLimitOrderVolume);
	printf("м۵µ=[%d]\n",pRspInstrument->MaxMarketOrderVolume);
	printf("м۵Сµ=[%d]\n",pRspInstrument->MinMarketOrderVolume);
	
	printf("=[%d]\n",pRspInstrument->VolumeMultiple);
	printf("۵λ=[%lf]\n",pRspInstrument->PriceTick);
	printf("=[%c]\n",pRspInstrument->Currency);
	printf("ͷ޲=[%d]\n",pRspInstrument->LongPosLimit);
	printf("ͷ޲=[%d]\n",pRspInstrument->ShortPosLimit);
	printf("ͣ=[%lf]\n",pRspInstrument->LowerLimitPrice);
	printf("ͣ=[%lf]\n",pRspInstrument->UpperLimitPrice);
	printf("=[%lf]\n",pRspInstrument->PreSettlementPrice);
	printf("Լ״̬=[%c]\n",pRspInstrument->InstrumentStatus);
	
	printf("=[%s]\n",pRspInstrument->CreateDate);
	printf("=[%s]\n",pRspInstrument->OpenDate);
	printf("=[%s]\n",pRspInstrument->ExpireDate);
	printf("ʼ=[%s]\n",pRspInstrument->StartDelivDate);
	printf("󽻸=[%s]\n",pRspInstrument->EndDelivDate);
	printf("ƻ׼=[%lf]\n",pRspInstrument->BasisPrice);
	printf("ǰǷ=[%d]\n",pRspInstrument->IsTrading);
	printf("Ʒ=[%s]\n",pRspInstrument->UnderlyingInstrID);
	printf("ֲ=[%c]\n",pRspInstrument->PositionType);
	printf("ִм=[%lf]\n",pRspInstrument->StrikePrice);
	printf("Ȩ=[%c]\n",pRspInstrument->OptionsType);
	printf("-----------------------------\n");
	
}
void CTraderSpi::OnRspQryInstrument(CUstpFtdcRspInstrumentField *pRspInstrument, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯױʧ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pRspInstrument==NULL)
	{
		printf("ûвѯԼ\n");
		return ;
	}
	
	Show(pRspInstrument);
	return ;
}

void CTraderSpi::OnRspQryTradingCode(CUstpFtdcRspTradingCodeField *pTradingCode, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯױʧ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pTradingCode==NULL)
	{
		printf("ûвѯױ\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("=[%s]\n",pTradingCode->ExchangeID);
	printf("͹˾=[%s]\n",pTradingCode->BrokerID);
	printf("Ͷ߱=[%s]\n",pTradingCode->InvestorID);
	printf("ͻ=[%s]\n",pTradingCode->ClientID);
	printf("ͻȨ=[%d]\n",pTradingCode->ClientRight);
	printf("ǷԾ=[%c]\n",pTradingCode->IsActive);
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRspQryInvestorPosition(CUstpFtdcRspInvestorPositionField *pRspInvestorPosition, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯͶֲ߳ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pRspInvestorPosition==NULL)
	{
		printf("ûвѯͶֲ߳\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("=[%s]\n",pRspInvestorPosition->ExchangeID);
	printf("͹˾=[%s]\n",pRspInvestorPosition->BrokerID);
	printf("Ͷ߱=[%s]\n",pRspInvestorPosition->InvestorID);
	printf("ͻ=[%s]\n",pRspInvestorPosition->ClientID);
	printf("Լ=[%s]\n",pRspInvestorPosition->InstrumentID);
	printf("=[%c]\n",pRspInvestorPosition->Direction);
	printf("ֲ=[%d]\n",pRspInvestorPosition->Position);
	printf("-----------------------------\n");
	return ;

}

	///ͶʲѯӦ
void CTraderSpi::OnRspQryInvestorFee(CUstpFtdcInvestorFeeField *pInvestorFee, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯͶʧ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pInvestorFee==NULL)
	{
		printf("ûвѯͶ\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("͹˾=[%s]\n",pInvestorFee->BrokerID);
	printf("Լ=[%s]\n",pInvestorFee->InstrumentID);
	printf("ͻ=[%s]\n",pInvestorFee->ClientID);
	printf("Ѱ=[%f]\n",pInvestorFee->OpenFeeRate);
	printf("Ѱ=[%f]\n",pInvestorFee->OpenFeeAmt);
	printf("ƽѰ=[%f]\n",pInvestorFee->OffsetFeeRate);
	printf("ƽѰ=[%f]\n",pInvestorFee->OffsetFeeAmt);
	printf("ƽѰ=[%f]\n",pInvestorFee->OTFeeRate);
	printf("ƽѰ=[%f]\n",pInvestorFee->OTFeeAmt);
	printf("-----------------------------\n");
	return ;

}

	///Ͷ֤߱ʲѯӦ
void CTraderSpi::OnRspQryInvestorMargin(CUstpFtdcInvestorMarginField *pInvestorMargin, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯͶ֤߱ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pInvestorMargin==NULL)
	{
		printf("ûвѯͶ֤߱\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("͹˾=[%s]\n",pInvestorMargin->BrokerID);
	printf("Լ=[%s]\n",pInvestorMargin->InstrumentID);
	printf("ͻ=[%s]\n",pInvestorMargin->ClientID);
	printf("ͷռñ֤𰴱=[%f]\n",pInvestorMargin->LongMarginRate);
	printf("ͷ֤=[%f]\n",pInvestorMargin->LongMarginAmt);
	printf("ͷռñ֤𰴱=[%f]\n",pInvestorMargin->ShortMarginRate);
	printf("ͷ֤=[%f]\n",pInvestorMargin->ShortMarginAmt);
	printf("-----------------------------\n");
	return ;

}


void CTraderSpi::OnRspQryComplianceParam(CUstpFtdcRspComplianceParamField *pRspComplianceParam, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("ѯϹʧ ԭ%s\n",pRspInfo->ErrorMsg);
		return;
	}
	
	if (pRspComplianceParam==NULL)
	{
		printf("ûвѯϹ\n");
		return ;
	}
	printf("-----------------------------\n");
	printf("͹˾=[%s]\n",pRspComplianceParam->BrokerID);
	printf("ͻ=[%s]\n",pRspComplianceParam->ClientID);
	printf("ÿ󱨵=[%d]\n",pRspComplianceParam->DailyMaxOrder);
	printf("ÿ󳷵=[%d]\n",pRspComplianceParam->DailyMaxOrderAction);
	printf("ÿ=[%d]\n",pRspComplianceParam->DailyMaxErrorOrder);
	printf("ÿ󱨵=[%d]\n",pRspComplianceParam->DailyMaxOrderVolume);
	printf("ÿ󳷵=[%d]\n",pRspComplianceParam->DailyMaxOrderActionVolume);
	printf("-----------------------------\n");
	return ;


}


int icount=0;
void CTraderSpi::OnRtnInstrumentStatus(CUstpFtdcInstrumentStatusField *pInstrumentStatus)
{
	if (pInstrumentStatus==NULL)
	{
		printf("ûкԼ״̬Ϣ\n");
		return ;
	}
	icount++;
	
	printf("-----------------------------\n");
	printf("=[%s]\n",pInstrumentStatus->ExchangeID);
	printf("Ʒִ=[%s]\n",pInstrumentStatus->ProductID);
	printf("Ʒ=[%s]\n",pInstrumentStatus->ProductName);
	printf("Լ=[%s]\n",pInstrumentStatus->InstrumentID);
	printf("Լ=[%s]\n",pInstrumentStatus->InstrumentName);
	printf("=[%d]\n",pInstrumentStatus->DeliveryYear);
	printf("=[%d]\n",pInstrumentStatus->DeliveryMonth);
	printf("޼۵µ=[%d]\n",pInstrumentStatus->MaxLimitOrderVolume);
	printf("޼۵Сµ=[%d]\n",pInstrumentStatus->MinLimitOrderVolume);
	printf("м۵µ=[%d]\n",pInstrumentStatus->MaxMarketOrderVolume);
	printf("м۵Сµ=[%d]\n",pInstrumentStatus->MinMarketOrderVolume);
	
	printf("=[%d]\n",pInstrumentStatus->VolumeMultiple);
	printf("۵λ=[%lf]\n",pInstrumentStatus->PriceTick);
	printf("=[%c]\n",pInstrumentStatus->Currency);
	printf("ͷ޲=[%d]\n",pInstrumentStatus->LongPosLimit);
	printf("ͷ޲=[%d]\n",pInstrumentStatus->ShortPosLimit);
	printf("ͣ=[%lf]\n",pInstrumentStatus->LowerLimitPrice);
	printf("ͣ=[%lf]\n",pInstrumentStatus->UpperLimitPrice);
	printf("=[%lf]\n",pInstrumentStatus->PreSettlementPrice);
	printf("Լ״̬=[%c]\n",pInstrumentStatus->InstrumentStatus);
	
	printf("=[%s]\n",pInstrumentStatus->CreateDate);
	printf("=[%s]\n",pInstrumentStatus->OpenDate);
	printf("=[%s]\n",pInstrumentStatus->ExpireDate);
	printf("ʼ=[%s]\n",pInstrumentStatus->StartDelivDate);
	printf("󽻸=[%s]\n",pInstrumentStatus->EndDelivDate);
	printf("ƻ׼=[%lf]\n",pInstrumentStatus->BasisPrice);
	printf("ǰǷ=[%d]\n",pInstrumentStatus->IsTrading);
	printf("Ʒ=[%s]\n",pInstrumentStatus->UnderlyingInstrID);
	printf("ֲ=[%c]\n",pInstrumentStatus->PositionType);
	printf("ִм=[%lf]\n",pInstrumentStatus->StrikePrice);
	printf("Ȩ=[%c]\n",pInstrumentStatus->OptionsType);

	printf("-----------------------------\n");
	printf("[%d]",icount);
	return ;

}


void CTraderSpi::OnRtnInvestorAccountDeposit(CUstpFtdcInvestorAccountDepositResField *pInvestorAccountDepositRes)
{
	if (pInvestorAccountDepositRes==NULL)
	{
		printf("ûʽϢ\n");
		return ;
	}

	printf("-----------------------------\n");
	printf("͹˾=[%s]\n",pInvestorAccountDepositRes->BrokerID);
	printf("û룽[%s]\n",pInvestorAccountDepositRes->UserID);
	printf("Ͷ߱=[%s]\n",pInvestorAccountDepositRes->InvestorID);
	printf("ʽ˺=[%s]\n",pInvestorAccountDepositRes->AccountID);
	printf("ʽˮţ[%s]\n",pInvestorAccountDepositRes->AccountSeqNo);
	printf("[%s]\n",pInvestorAccountDepositRes->Amount);
	printf("[%s]\n",pInvestorAccountDepositRes->AmountDirection);
	printf("ʽ[%s]\n",pInvestorAccountDepositRes->Available);
	printf("׼[%s]\n",pInvestorAccountDepositRes->Balance);
	printf("-----------------------------\n");
	return ;

}

void CTraderSpi::OnRspQuoteInsert(CUstpFtdcInputQuoteField* pInputQuote, CUstpFtdcRspInfoField* pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("¼ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pInputQuote==NULL)
	{
		printf("ûб¼\n");
		return;
	}
	printf("-----------------------------\n");
	printf("¼ɹ\n");
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRspQuoteAction(CUstpFtdcQuoteActionField* pQuoteAction, CUstpFtdcRspInfoField* pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pQuoteAction==NULL)
	{
		printf("ûг\n");
		return;
	}
	printf("-----------------------------\n");
	printf("۳ɹ\n");
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRspForQuote(CUstpFtdcReqForQuoteField* pReqForQuote, CUstpFtdcRspInfoField* pRspInfo, int nRequestID, bool bIsLast)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("ѯʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if(pReqForQuote==NULL)
	{
		printf("ûѯ\n");
		return;
	}
	printf("-----------------------------\n");
	printf("ѯ۳ɹ\n");
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnRtnQuote(CUstpFtdcRtnQuoteField* pRtnQuote)
{
	printf("-----------------------------\n");
	printf("յۻر\n");
	Show(pRtnQuote);
	printf("-----------------------------\n");
	return ;
}

void CTraderSpi::OnErrRtnQuoteInsert(CUstpFtdcInputQuoteField* pInputQuote, CUstpFtdcRspInfoField* pRspInfo)
{
	if (pRspInfo!=NULL&&pRspInfo->ErrorID!=0)
	{
		printf("-----------------------------\n");
		printf("¼رʧ ԭ%s\n",pRspInfo->ErrorMsg);
		printf("-----------------------------\n");
		return;
	}
	if( pInputQuote==NULL)
	{
		printf("û\n");
		return;
	}
	printf("-----------------------------\n");
	printf("¼ر\n");
	printf("-----------------------------\n");
	return ;
}
void CTraderSpi::Show(CUstpFtdcRtnQuoteField* pQuote)
{
	printf("-----------------------------\n");
	printf("=[%s]\n",pQuote->ExchangeID);
	printf("Ͷ߱=[%s]\n",pQuote->InvestorID);
	printf("û=[%s]\n",pQuote->UserID);
	printf("Լ=[%s]\n",pQuote->InstrumentID);
	printf("ϵͳ۱=[%s]\n",pQuote->QuoteSysID);
	printf("ûر۱=[%s]\n",pQuote->UserQuoteLocalID);
	printf("ر۱=[%s]\n",pQuote->QuoteLocalID);

	printf("=[%d]\n",pQuote->BidVolume);
	printf("򷽿ƽ־=[%c]\n",pQuote->BidOffsetFlag);
	printf("Ͷױ־=[%c]\n",pQuote->BidHedgeFlag);
	printf("۸=[%lf]\n",pQuote->BidPrice);
	printf("=[%d]\n",pQuote->AskVolume);
	printf("ƽ־=[%c]\n",pQuote->AskOffsetFlag);
	printf("Ͷױ־=[%c]\n",pQuote->AskHedgeFlag);
	printf("۸=[%lf]\n",pQuote->AskPrice);

	printf("ֳûر=[%s]\n",pQuote->BidUserOrderLocalID);
	printf("ֳûر=[%s]\n",pQuote->AskUserOrderLocalID);
	printf("ϵͳ=[%s]\n",pQuote->BidOrderSysID);
	printf("ϵͳ=[%s]\n",pQuote->AskOrderSysID);

	printf("۵״̬=[%s]\n",pQuote->QuoteStatus);


	printf("ʱ=[%s]\n",pQuote->InsertTime);
	printf("ʱ=[%s]\n",pQuote->CancelTime);
	printf("ɽʱ=[%s]\n",pQuote->TradeTime);

	printf("-----------------------------\n");
	return ;
}
